# wikitude_studio_api_client.ObjectTargetCollectionApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_object_target_collection**](ObjectTargetCollectionApi.md#create_object_target_collection) | **POST** /objectTargetCollection | Create Object Target Collection
[**delete_object_target_collection**](ObjectTargetCollectionApi.md#delete_object_target_collection) | **DELETE** /objectTargetCollection/{tcId} | Delete Object Target Collection
[**generate_wto**](ObjectTargetCollectionApi.md#generate_wto) | **POST** /objectTargetCollection/{tcId}/generation/wto | Generate WTO
[**get_object_target_collection**](ObjectTargetCollectionApi.md#get_object_target_collection) | **GET** /objectTargetCollection/{tcId} | Get Object Target Collection
[**get_object_target_collection_status**](ObjectTargetCollectionApi.md#get_object_target_collection_status) | **GET** /objectTargetCollection/{tcId}/jobs | Status - Get Object Target Collection jobs
[**get_object_target_collections**](ObjectTargetCollectionApi.md#get_object_target_collections) | **GET** /objectTargetCollection | Get all Object Target Collections
[**get_wto_status**](ObjectTargetCollectionApi.md#get_wto_status) | **GET** /objectTargetCollection/{tcId}/generation/wto/{generationId} | Status - Generate WTO
[**update_object_target_collection**](ObjectTargetCollectionApi.md#update_object_target_collection) | **PUT** /objectTargetCollection/{tcId} | Update Object Target Collection


# **create_object_target_collection**
> ObjectTargetCollectionResponse create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body)

Create Object Target Collection

Create a new Object Target Collection in your account.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.create_object_target_collection_body import CreateObjectTargetCollectionBody
from wikitude_studio_api_client.model.object_target_collection_response import ObjectTargetCollectionResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    content_type = "Content-Type_example" # str | The Content Type of the body. Must be set to application/json.
    create_object_target_collection_body = CreateObjectTargetCollectionBody(
        name="Some Target Collection",
        sdk_version="8.0",
        metadata={},
    ) # CreateObjectTargetCollectionBody | 

    # example passing only required values which don't have defaults set
    try:
        # Create Object Target Collection
        api_response = api_instance.create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->create_object_target_collection: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **content_type** | **str**| The Content Type of the body. Must be set to application/json. |
 **create_object_target_collection_body** | [**CreateObjectTargetCollectionBody**](CreateObjectTargetCollectionBody.md)|  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_object_target_collection**
> delete_object_target_collection(x_version, x_token, tc_id)

Delete Object Target Collection

Delete a Object Target Collection and all its Object Targets.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.

    # example passing only required values which don't have defaults set
    try:
        # Delete Object Target Collection
        api_instance.delete_object_target_collection(x_version, x_token, tc_id)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->delete_object_target_collection: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**204** | Successful operation - Empty response body. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **generate_wto**
> ObjectTargetCollectionJobResponse generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body)

Generate WTO

Generate a WTO file containing the Object Target Collection and all its Object Targets.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.object_target_collection_job_response import ObjectTargetCollectionJobResponse
from wikitude_studio_api_client.model.generate_wto_body import GenerateWTOBody
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    content_type = "Content-Type_example" # str | The Content Type of the body. Must be set to application/json.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.
    generate_wto_body = GenerateWTOBody(
        sdk_version="8.0",
        e_mail="noreply@wikitude.com",
    ) # GenerateWTOBody | 

    # example passing only required values which don't have defaults set
    try:
        # Generate WTO
        api_response = api_instance.generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->generate_wto: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **content_type** | **str**| The Content Type of the body. Must be set to application/json. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |
 **generate_wto_body** | [**GenerateWTOBody**](GenerateWTOBody.md)|  |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | Returns job status. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**412** | OBJECT_TARGET_COLLECTION_IS_EMPTY  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_object_target_collection**
> ObjectTargetCollectionResponse get_object_target_collection(x_version, x_token, tc_id)

Get Object Target Collection

Request a particular Object Target Collection from your account.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.object_target_collection_response import ObjectTargetCollectionResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.

    # example passing only required values which don't have defaults set
    try:
        # Get Object Target Collection
        api_response = api_instance.get_object_target_collection(x_version, x_token, tc_id)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_object_target_collection: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_object_target_collection_status**
> [ObjectTargetJobResponse] get_object_target_collection_status(x_version, x_token, tc_id)

Status - Get Object Target Collection jobs

Retrieves a list of asynchronous jobs sorted by creation date.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.object_target_job_response import ObjectTargetJobResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.
    skip = 0 # int | Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 (optional)
    limit = 1000 # int | Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 (optional)
    source = "api" # str | filter the jobs by source. Available values (api, studio). Default value: api (optional)
    type = "api" # str | filter the jobs by type. (optional)

    # example passing only required values which don't have defaults set
    try:
        # Status - Get Object Target Collection jobs
        api_response = api_instance.get_object_target_collection_status(x_version, x_token, tc_id)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_object_target_collection_status: %s\n" % e)

    # example passing only required values which don't have defaults set
    # and optional values
    try:
        # Status - Get Object Target Collection jobs
        api_response = api_instance.get_object_target_collection_status(x_version, x_token, tc_id, skip=skip, limit=limit, source=source, type=type)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_object_target_collection_status: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |
 **skip** | **int**| Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 | [optional]
 **limit** | **int**| Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 | [optional]
 **source** | **str**| filter the jobs by source. Available values (api, studio). Default value: api | [optional]
 **type** | **str**| filter the jobs by type. | [optional]

### Return type

[**[ObjectTargetJobResponse]**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Returns a list of the asynchronous jobs. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_object_target_collections**
> [ObjectTargetCollectionResponse] get_object_target_collections(x_version, x_token)

Get all Object Target Collections

Request all Object Target Collections from your account.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.object_target_collection_response import ObjectTargetCollectionResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    skip = 1 # int | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
    limit = 1 # int | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)

    # example passing only required values which don't have defaults set
    try:
        # Get all Object Target Collections
        api_response = api_instance.get_object_target_collections(x_version, x_token)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_object_target_collections: %s\n" % e)

    # example passing only required values which don't have defaults set
    # and optional values
    try:
        # Get all Object Target Collections
        api_response = api_instance.get_object_target_collections(x_version, x_token, skip=skip, limit=limit)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_object_target_collections: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **skip** | **int**| Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional]
 **limit** | **int**| Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional]

### Return type

[**[ObjectTargetCollectionResponse]**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful response |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | FEATURE_NOT_SUPPORTED  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_wto_status**
> ObjectTargetCollectionJobResponse get_wto_status(x_version, x_token, tc_id, generation_id)

Status - Generate WTO

Retrieves information status about a particular scheduled wto generation.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.object_target_collection_job_response import ObjectTargetCollectionJobResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.
    generation_id = "generationId_example" # str | Unique identifier of the asynchronous job created by a generation endpoint.

    # example passing only required values which don't have defaults set
    try:
        # Status - Generate WTO
        api_response = api_instance.get_wto_status(x_version, x_token, tc_id, generation_id)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->get_wto_status: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |
 **generation_id** | **str**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Returns status of the asynchronous job. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_object_target_collection**
> ObjectTargetCollectionResponse update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body)

Update Object Target Collection

Updates an existing Object Target Collection in your account.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import object_target_collection_api
from wikitude_studio_api_client.model.update_object_target_collection_body import UpdateObjectTargetCollectionBody
from wikitude_studio_api_client.model.object_target_collection_response import ObjectTargetCollectionResponse
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = object_target_collection_api.ObjectTargetCollectionApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    content_type = "Content-Type_example" # str | The Content Type of the body. Must be set to application/json.
    tc_id = "tcId_example" # str | Unique identifier of the Object Target Collection.
    update_object_target_collection_body = UpdateObjectTargetCollectionBody(
        name="Some Target Collection",
        metadata={},
    ) # UpdateObjectTargetCollectionBody | 

    # example passing only required values which don't have defaults set
    try:
        # Update Object Target Collection
        api_response = api_instance.update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ObjectTargetCollectionApi->update_object_target_collection: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **content_type** | **str**| The Content Type of the body. Must be set to application/json. |
 **tc_id** | **str**| Unique identifier of the Object Target Collection. |
 **update_object_target_collection_body** | [**UpdateObjectTargetCollectionBody**](UpdateObjectTargetCollectionBody.md)|  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

