# wikitude_studio_api_client.ProjectApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_projects**](ProjectApi.md#get_projects) | **GET** /projects | Get all projects


# **get_projects**
> [object] get_projects(x_version, x_token)

Get all projects

Request all projects from your account.

### Example

```python
import time
import wikitude_studio_api_client
from wikitude_studio_api_client.api import project_api
from pprint import pprint
# Defining the host is optional and defaults to https://api-eu.wikitude.com/cloudrecognition
# See configuration.py for a list of all supported configuration parameters.
configuration = wikitude_studio_api_client.Configuration(
    host = "https://api-eu.wikitude.com/cloudrecognition"
)


# Enter a context with an instance of the API client
with wikitude_studio_api_client.ApiClient() as api_client:
    # Create an instance of the API class
    api_instance = project_api.ProjectApi(api_client)
    x_version = "3" # str | The version of the API to be used. Must be set to 3.
    x_token = "X-Token_example" # str | Your Manager Token.
    skip = 1 # int | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
    limit = 1 # int | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)

    # example passing only required values which don't have defaults set
    try:
        # Get all projects
        api_response = api_instance.get_projects(x_version, x_token)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ProjectApi->get_projects: %s\n" % e)

    # example passing only required values which don't have defaults set
    # and optional values
    try:
        # Get all projects
        api_response = api_instance.get_projects(x_version, x_token, skip=skip, limit=limit)
        pprint(api_response)
    except wikitude_studio_api_client.ApiException as e:
        print("Exception when calling ProjectApi->get_projects: %s\n" % e)
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_version** | **str**| The version of the API to be used. Must be set to 3. |
 **x_token** | **str**| Your Manager Token. |
 **skip** | **int**| Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional]
 **limit** | **int**| Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional]

### Return type

**[object]**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The Array of Projects in your account |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

