"""
    Wikitude Studio API

    The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wikitude_studio_api_client.api_client import ApiClient, Endpoint as _Endpoint
from wikitude_studio_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from wikitude_studio_api_client.model.generate_heatmap_body import GenerateHeatmapBody
from wikitude_studio_api_client.model.generate_heatmap_response import GenerateHeatmapResponse
from wikitude_studio_api_client.model.generate_heatmap_status_response import GenerateHeatmapStatusResponse


class HeatmapApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __generate_heatmap(
            self,
            x_version,
            x_token,
            content_type,
            generate_heatmap_body,
            **kwargs
        ):
            """Generate Heatmap  # noqa: E501

            Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.generate_heatmap(x_version, x_token, content_type, generate_heatmap_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                generate_heatmap_body (GenerateHeatmapBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                GenerateHeatmapResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['generate_heatmap_body'] = \
                generate_heatmap_body
            return self.call_with_http_info(**kwargs)

        self.generate_heatmap = _Endpoint(
            settings={
                'response_type': (GenerateHeatmapResponse,),
                'auth': [],
                'endpoint_path': '/heatmap',
                'operation_id': 'generate_heatmap',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'generate_heatmap_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'generate_heatmap_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'generate_heatmap_body':
                        (GenerateHeatmapBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'generate_heatmap_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__generate_heatmap
        )

        def __get_heatmap_status(
            self,
            x_version,
            x_token,
            generation_id,
            **kwargs
        ):
            """Status - Generate Heatmap  # noqa: E501

            Retrieves information status about a particular scheduled heatmap creation.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_heatmap_status(x_version, x_token, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                GenerateHeatmapStatusResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_heatmap_status = _Endpoint(
            settings={
                'response_type': (GenerateHeatmapStatusResponse,),
                'auth': [],
                'endpoint_path': '/heatmap/{generationId}',
                'operation_id': 'get_heatmap_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_heatmap_status
        )
