"""
    Wikitude Studio API

    The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wikitude_studio_api_client.api_client import ApiClient, Endpoint as _Endpoint
from wikitude_studio_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from wikitude_studio_api_client.model.create_image_targets_body import CreateImageTargetsBody
from wikitude_studio_api_client.model.create_image_targets_response import CreateImageTargetsResponse
from wikitude_studio_api_client.model.image_target_response import ImageTargetResponse
from wikitude_studio_api_client.model.update_image_target_body import UpdateImageTargetBody


class ImageTargetApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __create_image_targets(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            **kwargs
        ):
            """Create Image Targets  # noqa: E501

            Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \"Location\"-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \"estimatedLatency\" milliseconds, and poll it afterwards every 10 seconds in case job status is still not \"COMPLETED\". Once job status is \"COMPLETED\" each item holds a \"target\" attribute of the created target or an \"error\" attribute.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_image_targets(x_version, x_token, content_type, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Image Target Collection.

            Keyword Args:
                create_image_targets_body ([CreateImageTargetsBody]): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                CreateImageTargetsResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.create_image_targets = _Endpoint(
            settings={
                'response_type': (CreateImageTargetsResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/targets',
                'operation_id': 'create_image_targets',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'create_image_targets_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'create_image_targets_body':
                        ([CreateImageTargetsBody],),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'create_image_targets_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_image_targets
        )

        def __delete_image_target(
            self,
            x_version,
            x_token,
            tc_id,
            target_id,
            **kwargs
        ):
            """Delete Image Target  # noqa: E501

            Delete a particular Target from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_image_target(x_version, x_token, tc_id, target_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                target_id (str): Unique identifier of the Image Target.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            return self.call_with_http_info(**kwargs)

        self.delete_image_target = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/target/{targetId}',
                'operation_id': 'delete_image_target',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_image_target
        )

        def __get_image_target(
            self,
            x_version,
            x_token,
            tc_id,
            target_id,
            **kwargs
        ):
            """Get Image Target  # noqa: E501

            Request a particular Image Target in a particular Target Collection.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_image_target(x_version, x_token, tc_id, target_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                target_id (str): Unique identifier of the Image Target.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ImageTargetResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            return self.call_with_http_info(**kwargs)

        self.get_image_target = _Endpoint(
            settings={
                'response_type': (ImageTargetResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/target/{targetId}',
                'operation_id': 'get_image_target',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_image_target
        )

        def __get_image_target_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Image Targets Creation  # noqa: E501

            Retrieves information status about a particular scheduled targets creation.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_image_target_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                CreateImageTargetsResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_image_target_status = _Endpoint(
            settings={
                'response_type': (CreateImageTargetsResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/generation/targets/{generationId}',
                'operation_id': 'get_image_target_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_image_target_status
        )

        def __get_image_targets(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Get Image Targets  # noqa: E501

            Request all Image Targets in a Target Collection.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_image_targets(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.

            Keyword Args:
                sortby (str): Targets may be sorted by 'name', 'creDat', 'modDat', 'rating'. Default value: 'creDat'. [optional]
                sortorder (str): Targets may be sorted ascending ('asc') or descending ('desc'). Default value: 'desc'. [optional]
                skip (float): Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0. [optional]
                limit (float): Set to 0 for 'all targets' or use positive value to define max. amount of targets to return. Default value: 0. [optional]
                s (str): The search string to look for in target names.. [optional]
                add_has_augmentations (bool): Add the hasAugmentations property.. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ImageTargetResponse]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.get_image_targets = _Endpoint(
            settings={
                'response_type': ([ImageTargetResponse],),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/target',
                'operation_id': 'get_image_targets',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'sortby',
                    'sortorder',
                    'skip',
                    'limit',
                    's',
                    'add_has_augmentations',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'sortby':
                        (str,),
                    'sortorder':
                        (str,),
                    'skip':
                        (float,),
                    'limit':
                        (float,),
                    's':
                        (str,),
                    'add_has_augmentations':
                        (bool,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'sortby': 'sortby',
                    'sortorder': 'sortorder',
                    'skip': 'skip',
                    'limit': 'limit',
                    's': 's',
                    'add_has_augmentations': 'addHasAugmentations',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'sortby': 'query',
                    'sortorder': 'query',
                    'skip': 'query',
                    'limit': 'query',
                    's': 'query',
                    'add_has_augmentations': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_image_targets
        )

        def __update_image_target(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            target_id,
            update_image_target_body,
            **kwargs
        ):
            """Update Image Target  # noqa: E501

            Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_image_target(x_version, x_token, content_type, tc_id, target_id, update_image_target_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Image Target Collection.
                target_id (str): Unique identifier of the Image Target.
                update_image_target_body (UpdateImageTargetBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ImageTargetResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            kwargs['update_image_target_body'] = \
                update_image_target_body
            return self.call_with_http_info(**kwargs)

        self.update_image_target = _Endpoint(
            settings={
                'response_type': (ImageTargetResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/target/{targetId}',
                'operation_id': 'update_image_target',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'update_image_target_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'update_image_target_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                    'update_image_target_body':
                        (UpdateImageTargetBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                    'update_image_target_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_image_target
        )
