"""
    Wikitude Studio API

    The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wikitude_studio_api_client.api_client import ApiClient, Endpoint as _Endpoint
from wikitude_studio_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from wikitude_studio_api_client.model.cloud_archive_generation_response import CloudArchiveGenerationResponse
from wikitude_studio_api_client.model.create_image_target_collection_body import CreateImageTargetCollectionBody
from wikitude_studio_api_client.model.generate_wtc_body import GenerateWTCBody
from wikitude_studio_api_client.model.generate_wtc_status_response import GenerateWTCStatusResponse
from wikitude_studio_api_client.model.image_target_collection_response import ImageTargetCollectionResponse
from wikitude_studio_api_client.model.similarity_check_body import SimilarityCheckBody
from wikitude_studio_api_client.model.similarity_check_response import SimilarityCheckResponse
from wikitude_studio_api_client.model.similarity_check_status_response import SimilarityCheckStatusResponse
from wikitude_studio_api_client.model.update_image_target_collection_body import UpdateImageTargetCollectionBody


class ImageTargetCollectionApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __create_image_target_collection(
            self,
            x_version,
            x_token,
            content_type,
            create_image_target_collection_body,
            **kwargs
        ):
            """Create Image Target Collection  # noqa: E501

            Create a new target collection in your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_image_target_collection(x_version, x_token, content_type, create_image_target_collection_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                create_image_target_collection_body (CreateImageTargetCollectionBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ImageTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['create_image_target_collection_body'] = \
                create_image_target_collection_body
            return self.call_with_http_info(**kwargs)

        self.create_image_target_collection = _Endpoint(
            settings={
                'response_type': (ImageTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection',
                'operation_id': 'create_image_target_collection',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'create_image_target_collection_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'create_image_target_collection_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'create_image_target_collection_body':
                        (CreateImageTargetCollectionBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'create_image_target_collection_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_image_target_collection
        )

        def __delete_image_target_collection(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Delete Image Target Collection  # noqa: E501

            Delete a particular target collection from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_image_target_collection(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.delete_image_target_collection = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}',
                'operation_id': 'delete_image_target_collection',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_image_target_collection
        )

        def __generate_cloud_archive(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Generate Cloud Archive  # noqa: E501

            DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \"deprecated\" since the behaviour will slightly change. However, this endpoint will still exist in version 3.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.generate_cloud_archive(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                CloudArchiveGenerationResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.generate_cloud_archive = _Endpoint(
            settings={
                'response_type': (CloudArchiveGenerationResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/generation/cloudarchive',
                'operation_id': 'generate_cloud_archive',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__generate_cloud_archive
        )

        def __generate_wtc(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            generate_wtc_body,
            **kwargs
        ):
            """Generate WTC  # noqa: E501

            Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC).   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.generate_wtc(x_version, x_token, content_type, tc_id, generate_wtc_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Image Target Collection.
                generate_wtc_body (GenerateWTCBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                GenerateWTCStatusResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['generate_wtc_body'] = \
                generate_wtc_body
            return self.call_with_http_info(**kwargs)

        self.generate_wtc = _Endpoint(
            settings={
                'response_type': (GenerateWTCStatusResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/generation/wtc',
                'operation_id': 'generate_wtc',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'generate_wtc_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'generate_wtc_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'generate_wtc_body':
                        (GenerateWTCBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'generate_wtc_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__generate_wtc
        )

        def __get_cloud_archive_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Generate Cloud Archive  # noqa: E501

            Retrieves information status about a particular scheduled cloud archive generation.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_cloud_archive_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                CloudArchiveGenerationResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_cloud_archive_status = _Endpoint(
            settings={
                'response_type': (CloudArchiveGenerationResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/generation/cloudarchive/{generationId}',
                'operation_id': 'get_cloud_archive_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_cloud_archive_status
        )

        def __get_image_target_collection(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Get Image Target Collection  # noqa: E501

            Request a particular target collection from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_image_target_collection(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ImageTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.get_image_target_collection = _Endpoint(
            settings={
                'response_type': (ImageTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}',
                'operation_id': 'get_image_target_collection',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_image_target_collection
        )

        def __get_image_target_collections(
            self,
            x_version,
            x_token,
            **kwargs
        ):
            """Get all Image Target Collections  # noqa: E501

            Request all target collections from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_image_target_collections(x_version, x_token, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.

            Keyword Args:
                skip (int): Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0. [optional]
                limit (int): Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ImageTargetCollectionResponse]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            return self.call_with_http_info(**kwargs)

        self.get_image_target_collections = _Endpoint(
            settings={
                'response_type': ([ImageTargetCollectionResponse],),
                'auth': [],
                'endpoint_path': '/targetCollection',
                'operation_id': 'get_image_target_collections',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'skip',
                    'limit',
                ],
                'required': [
                    'x_version',
                    'x_token',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'skip':
                        (int,),
                    'limit':
                        (int,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'skip': 'skip',
                    'limit': 'limit',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'skip': 'query',
                    'limit': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_image_target_collections
        )

        def __get_similarity_check_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Similarity Check  # noqa: E501

            Retrieves information status of a particular scheduled \"Similarity Check\".  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_similarity_check_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                SimilarityCheckStatusResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_similarity_check_status = _Endpoint(
            settings={
                'response_type': (SimilarityCheckStatusResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/similarity/{generationId}',
                'operation_id': 'get_similarity_check_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_similarity_check_status
        )

        def __get_wtc_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Generate WTC  # noqa: E501

            Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection).   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_wtc_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Image Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                GenerateWTCStatusResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_wtc_status = _Endpoint(
            settings={
                'response_type': (GenerateWTCStatusResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/generation/wtc/{generationId}',
                'operation_id': 'get_wtc_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_wtc_status
        )

        def __similarity_check(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            similarity_check_body,
            **kwargs
        ):
            """Similarity Check  # noqa: E501

            Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \"candidates\" with a similarity \"score\" are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \"maxCandidates\" to define the maximum amount of candidates to return for an image. Response header value \"Location\" directly points to the right \"Status - Similarity Check\" endpoint. Best practice is to trigger \"Similarity Check\", wait for \"estimatedLatency\" milliseconds and poll \"Status - Similarity Check\" endpoint every 5 seconds until its \"status\" is \"COMPLETED\".   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.similarity_check(x_version, x_token, content_type, tc_id, similarity_check_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Image Target Collection.
                similarity_check_body (SimilarityCheckBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                SimilarityCheckResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['similarity_check_body'] = \
                similarity_check_body
            return self.call_with_http_info(**kwargs)

        self.similarity_check = _Endpoint(
            settings={
                'response_type': (SimilarityCheckResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}/similarity',
                'operation_id': 'similarity_check',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'similarity_check_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'similarity_check_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'similarity_check_body':
                        (SimilarityCheckBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'similarity_check_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__similarity_check
        )

        def __update_image_target_collection(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            update_image_target_collection_body,
            **kwargs
        ):
            """Update Image Target Collection  # noqa: E501

            Update a target collection from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_image_target_collection(x_version, x_token, content_type, tc_id, update_image_target_collection_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Image Target Collection.
                update_image_target_collection_body (UpdateImageTargetCollectionBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ImageTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['update_image_target_collection_body'] = \
                update_image_target_collection_body
            return self.call_with_http_info(**kwargs)

        self.update_image_target_collection = _Endpoint(
            settings={
                'response_type': (ImageTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/targetCollection/{tcId}',
                'operation_id': 'update_image_target_collection',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'update_image_target_collection_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'update_image_target_collection_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'update_image_target_collection_body':
                        (UpdateImageTargetCollectionBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'update_image_target_collection_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_image_target_collection
        )
