"""
    Wikitude Studio API

    The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wikitude_studio_api_client.api_client import ApiClient, Endpoint as _Endpoint
from wikitude_studio_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from wikitude_studio_api_client.model.create_object_target_images_body import CreateObjectTargetImagesBody
from wikitude_studio_api_client.model.create_object_target_wto_body import CreateObjectTargetWTOBody
from wikitude_studio_api_client.model.extend_object_target_body import ExtendObjectTargetBody
from wikitude_studio_api_client.model.object_target_job_response import ObjectTargetJobResponse
from wikitude_studio_api_client.model.object_target_response import ObjectTargetResponse
from wikitude_studio_api_client.model.rename_object_target_body import RenameObjectTargetBody


class ObjectTargetApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __create_object_target_from_images(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            create_object_target_images_body,
            **kwargs
        ):
            """Create Object Target from Images  # noqa: E501

            Create a new Object Target in an Object Target Collection from at least two Image files.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_object_target_from_images(x_version, x_token, content_type, tc_id, create_object_target_images_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                create_object_target_images_body (CreateObjectTargetImagesBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['create_object_target_images_body'] = \
                create_object_target_images_body
            return self.call_with_http_info(**kwargs)

        self.create_object_target_from_images = _Endpoint(
            settings={
                'response_type': (ObjectTargetJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/images',
                'operation_id': 'create_object_target_from_images',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'create_object_target_images_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'create_object_target_images_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'create_object_target_images_body':
                        (CreateObjectTargetImagesBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'create_object_target_images_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_object_target_from_images
        )

        def __create_object_target_from_wto(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            create_object_target_wto_body,
            **kwargs
        ):
            """Create Object Target from WTO  # noqa: E501

            Create a new Object Target in an Object Target Collection from a WTO file.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_object_target_from_wto(x_version, x_token, content_type, tc_id, create_object_target_wto_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                create_object_target_wto_body (CreateObjectTargetWTOBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['create_object_target_wto_body'] = \
                create_object_target_wto_body
            return self.call_with_http_info(**kwargs)

        self.create_object_target_from_wto = _Endpoint(
            settings={
                'response_type': (ObjectTargetJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/wto',
                'operation_id': 'create_object_target_from_wto',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'create_object_target_wto_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'create_object_target_wto_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'create_object_target_wto_body':
                        (CreateObjectTargetWTOBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'create_object_target_wto_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_object_target_from_wto
        )

        def __delete_object_target(
            self,
            x_version,
            x_token,
            tc_id,
            target_id,
            **kwargs
        ):
            """Delete Object Target  # noqa: E501

            Delete a particular Object Target from your Object Target Collection.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_object_target(x_version, x_token, tc_id, target_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.
                target_id (str): Unique identifier of the Object Target.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            return self.call_with_http_info(**kwargs)

        self.delete_object_target = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/{targetId}',
                'operation_id': 'delete_object_target',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_object_target
        )

        def __extend_object_target(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            target_id,
            extend_object_target_body,
            **kwargs
        ):
            """Extend Object Target  # noqa: E501

            Add source images to an existing target.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.extend_object_target(x_version, x_token, content_type, tc_id, target_id, extend_object_target_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                target_id (str): Unique identifier of the Object Target.
                extend_object_target_body (ExtendObjectTargetBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            kwargs['extend_object_target_body'] = \
                extend_object_target_body
            return self.call_with_http_info(**kwargs)

        self.extend_object_target = _Endpoint(
            settings={
                'response_type': (ObjectTargetJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/{targetId}',
                'operation_id': 'extend_object_target',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'extend_object_target_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'extend_object_target_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                    'extend_object_target_body':
                        (ExtendObjectTargetBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                    'extend_object_target_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__extend_object_target
        )

        def __get_object_target(
            self,
            x_version,
            x_token,
            tc_id,
            target_id,
            **kwargs
        ):
            """Get Object Target  # noqa: E501

            Request a specific Object Targets from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_target(x_version, x_token, tc_id, target_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.
                target_id (str): Unique identifier of the Object Target.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            return self.call_with_http_info(**kwargs)

        self.get_object_target = _Endpoint(
            settings={
                'response_type': (ObjectTargetResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/{targetId}',
                'operation_id': 'get_object_target',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'target_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_target
        )

        def __get_object_target_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Object Target Generation Information  # noqa: E501

            Retrieves information status about a particular scheduled Object Target creation.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_target_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_object_target_status = _Endpoint(
            settings={
                'response_type': (ObjectTargetJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/generation/targets/{generationId}',
                'operation_id': 'get_object_target_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_target_status
        )

        def __get_object_targets(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Get Object Targets  # noqa: E501

            Request all Object Targets in a Target Collection.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_targets(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ObjectTargetResponse]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.get_object_targets = _Endpoint(
            settings={
                'response_type': ([ObjectTargetResponse],),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target',
                'operation_id': 'get_object_targets',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_targets
        )

        def __rename_object_target(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            target_id,
            rename_object_target_body,
            **kwargs
        ):
            """Rename Object Target  # noqa: E501

            Rename an existing target.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.rename_object_target(x_version, x_token, content_type, tc_id, target_id, rename_object_target_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                target_id (str): Unique identifier of the Object Target.
                rename_object_target_body (RenameObjectTargetBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['target_id'] = \
                target_id
            kwargs['rename_object_target_body'] = \
                rename_object_target_body
            return self.call_with_http_info(**kwargs)

        self.rename_object_target = _Endpoint(
            settings={
                'response_type': (ObjectTargetJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/target/{targetId}/name',
                'operation_id': 'rename_object_target',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'rename_object_target_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'target_id',
                    'rename_object_target_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'target_id':
                        (str,),
                    'rename_object_target_body':
                        (RenameObjectTargetBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                    'target_id': 'targetId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'target_id': 'path',
                    'rename_object_target_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__rename_object_target
        )
