"""
    Wikitude Studio API

    The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wikitude_studio_api_client.api_client import ApiClient, Endpoint as _Endpoint
from wikitude_studio_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from wikitude_studio_api_client.model.create_object_target_collection_body import CreateObjectTargetCollectionBody
from wikitude_studio_api_client.model.generate_wto_body import GenerateWTOBody
from wikitude_studio_api_client.model.object_target_collection_job_response import ObjectTargetCollectionJobResponse
from wikitude_studio_api_client.model.object_target_collection_response import ObjectTargetCollectionResponse
from wikitude_studio_api_client.model.object_target_job_response import ObjectTargetJobResponse
from wikitude_studio_api_client.model.update_object_target_collection_body import UpdateObjectTargetCollectionBody


class ObjectTargetCollectionApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __create_object_target_collection(
            self,
            x_version,
            x_token,
            content_type,
            create_object_target_collection_body,
            **kwargs
        ):
            """Create Object Target Collection  # noqa: E501

            Create a new Object Target Collection in your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                create_object_target_collection_body (CreateObjectTargetCollectionBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['create_object_target_collection_body'] = \
                create_object_target_collection_body
            return self.call_with_http_info(**kwargs)

        self.create_object_target_collection = _Endpoint(
            settings={
                'response_type': (ObjectTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection',
                'operation_id': 'create_object_target_collection',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'create_object_target_collection_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'create_object_target_collection_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'create_object_target_collection_body':
                        (CreateObjectTargetCollectionBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'create_object_target_collection_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_object_target_collection
        )

        def __delete_object_target_collection(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Delete Object Target Collection  # noqa: E501

            Delete a Object Target Collection and all its Object Targets.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_object_target_collection(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.delete_object_target_collection = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}',
                'operation_id': 'delete_object_target_collection',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_object_target_collection
        )

        def __generate_wto(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            generate_wto_body,
            **kwargs
        ):
            """Generate WTO  # noqa: E501

            Generate a WTO file containing the Object Target Collection and all its Object Targets.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                generate_wto_body (GenerateWTOBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetCollectionJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['generate_wto_body'] = \
                generate_wto_body
            return self.call_with_http_info(**kwargs)

        self.generate_wto = _Endpoint(
            settings={
                'response_type': (ObjectTargetCollectionJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/generation/wto',
                'operation_id': 'generate_wto',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'generate_wto_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'generate_wto_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'generate_wto_body':
                        (GenerateWTOBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'generate_wto_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__generate_wto
        )

        def __get_object_target_collection(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Get Object Target Collection  # noqa: E501

            Request a particular Object Target Collection from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_target_collection(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.get_object_target_collection = _Endpoint(
            settings={
                'response_type': (ObjectTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}',
                'operation_id': 'get_object_target_collection',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_target_collection
        )

        def __get_object_target_collection_status(
            self,
            x_version,
            x_token,
            tc_id,
            **kwargs
        ):
            """Status - Get Object Target Collection jobs  # noqa: E501

            Retrieves a list of asynchronous jobs sorted by creation date.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_target_collection_status(x_version, x_token, tc_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.

            Keyword Args:
                skip (int): Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0. [optional]
                limit (int): Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10. [optional]
                source (str): filter the jobs by source. Available values (api, studio). Default value: api. [optional]
                type (str): filter the jobs by type.. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ObjectTargetJobResponse]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            return self.call_with_http_info(**kwargs)

        self.get_object_target_collection_status = _Endpoint(
            settings={
                'response_type': ([ObjectTargetJobResponse],),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/jobs',
                'operation_id': 'get_object_target_collection_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'skip',
                    'limit',
                    'source',
                    'type',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'skip':
                        (int,),
                    'limit':
                        (int,),
                    'source':
                        (str,),
                    'type':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'skip': 'skip',
                    'limit': 'limit',
                    'source': 'source',
                    'type': 'type',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'skip': 'query',
                    'limit': 'query',
                    'source': 'query',
                    'type': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_target_collection_status
        )

        def __get_object_target_collections(
            self,
            x_version,
            x_token,
            **kwargs
        ):
            """Get all Object Target Collections  # noqa: E501

            Request all Object Target Collections from your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_object_target_collections(x_version, x_token, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.

            Keyword Args:
                skip (int): Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0. [optional]
                limit (int): Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ObjectTargetCollectionResponse]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            return self.call_with_http_info(**kwargs)

        self.get_object_target_collections = _Endpoint(
            settings={
                'response_type': ([ObjectTargetCollectionResponse],),
                'auth': [],
                'endpoint_path': '/objectTargetCollection',
                'operation_id': 'get_object_target_collections',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'skip',
                    'limit',
                ],
                'required': [
                    'x_version',
                    'x_token',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'skip':
                        (int,),
                    'limit':
                        (int,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'skip': 'skip',
                    'limit': 'limit',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'skip': 'query',
                    'limit': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_object_target_collections
        )

        def __get_wto_status(
            self,
            x_version,
            x_token,
            tc_id,
            generation_id,
            **kwargs
        ):
            """Status - Generate WTO  # noqa: E501

            Retrieves information status about a particular scheduled wto generation.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_wto_status(x_version, x_token, tc_id, generation_id, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                tc_id (str): Unique identifier of the Object Target Collection.
                generation_id (str): Unique identifier of the asynchronous job created by a generation endpoint.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetCollectionJobResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['tc_id'] = \
                tc_id
            kwargs['generation_id'] = \
                generation_id
            return self.call_with_http_info(**kwargs)

        self.get_wto_status = _Endpoint(
            settings={
                'response_type': (ObjectTargetCollectionJobResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}/generation/wto/{generationId}',
                'operation_id': 'get_wto_status',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'tc_id',
                    'generation_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'tc_id':
                        (str,),
                    'generation_id':
                        (str,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'tc_id': 'tcId',
                    'generation_id': 'generationId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'tc_id': 'path',
                    'generation_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_wto_status
        )

        def __update_object_target_collection(
            self,
            x_version,
            x_token,
            content_type,
            tc_id,
            update_object_target_collection_body,
            **kwargs
        ):
            """Update Object Target Collection  # noqa: E501

            Updates an existing Object Target Collection in your account.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body, async_req=True)
            >>> result = thread.get()

            Args:
                x_version (str): The version of the API to be used. Must be set to 3.
                x_token (str): Your Manager Token.
                content_type (str): The Content Type of the body. Must be set to application/json.
                tc_id (str): Unique identifier of the Object Target Collection.
                update_object_target_collection_body (UpdateObjectTargetCollectionBody):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ObjectTargetCollectionResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['x_version'] = \
                x_version
            kwargs['x_token'] = \
                x_token
            kwargs['content_type'] = \
                content_type
            kwargs['tc_id'] = \
                tc_id
            kwargs['update_object_target_collection_body'] = \
                update_object_target_collection_body
            return self.call_with_http_info(**kwargs)

        self.update_object_target_collection = _Endpoint(
            settings={
                'response_type': (ObjectTargetCollectionResponse,),
                'auth': [],
                'endpoint_path': '/objectTargetCollection/{tcId}',
                'operation_id': 'update_object_target_collection',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'update_object_target_collection_body',
                ],
                'required': [
                    'x_version',
                    'x_token',
                    'content_type',
                    'tc_id',
                    'update_object_target_collection_body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_version':
                        (str,),
                    'x_token':
                        (str,),
                    'content_type':
                        (str,),
                    'tc_id':
                        (str,),
                    'update_object_target_collection_body':
                        (UpdateObjectTargetCollectionBody,),
                },
                'attribute_map': {
                    'x_version': 'X-Version',
                    'x_token': 'X-Token',
                    'content_type': 'Content-Type',
                    'tc_id': 'tcId',
                },
                'location_map': {
                    'x_version': 'header',
                    'x_token': 'header',
                    'content_type': 'header',
                    'tc_id': 'path',
                    'update_object_target_collection_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_object_target_collection
        )
